unit CMain;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes,
  System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs,
  System.Permissions,
  Androidapi.JNI.Os,
  FMX.Controls.Presentation, FMX.StdCtrls, FMX.Edit;

type
  TFormMain = class(TForm)
    btnPermission: TButton;
    btnInstall: TButton;
    edtApk: TEdit;
    procedure btnPermissionClick(Sender: TObject);
    procedure btnInstallClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormMain: TFormMain;

implementation

uses Androidapi.Helpers, Androidapi.JNI.GraphicsContentViewText,
  Androidapi.JNI.Net, Androidapi.JNI.App, Androidapi.JNI.JavaTypes,
  Androidapi.JNI.Support;

{$R *.fmx}

procedure TFormMain.btnInstallClick(Sender: TObject);
var
  uri: Jnet_Uri;
  LAuthority: JString;
  AFile: JFile;
  intent: JIntent;
  context:JContext;
begin
  //
  AFile := TJFile.JavaClass.init(StringToJString(edtApk.Text.Trim));
//  context:=SharedActivityContext;
//  LAuthority := context.getApplicationContext.getPackageName.
//    concat(StringToJString('.provider'));
////
//  uri := TJFileProvider.JavaClass.getUriForFile(context,
//    LAuthority, AFile);

//  if not AFile.exists then
//  begin
//    case MessageDlg('No file exists', System.UITypes.TMsgDlgType.mtInformation,
//    [
//    System.UITypes.TMsgDlgBtn.mbYes
//    ], 0) of
//    { Detect which button was pushed and show a different message }
//    mrYes:
//    begin
//    // pressed yes
//      Exit;
//    end;
//
//    end;
//  end
//  else
//  begin
    uri:=TAndroidHelper.JFileToJURI(AFile);

    Intent := TJIntent.Create;
    if TOSVersion.Check(8, 0) then
      Intent.setAction(TJIntent.JavaClass.ACTION_INSTALL_PACKAGE)
    else
      Intent.setAction(TJIntent.JavaClass.ACTION_VIEW);

    intent.addFlags(TJIntent.JavaClass.FLAG_GRANT_READ_URI_PERMISSION or
      TJIntent.JavaClass.FLAG_GRANT_WRITE_URI_PERMISSION);
    intent.addFlags(TJIntent.JavaClass.FLAG_ACTIVITY_NEW_TASK);
    intent.setDataAndType(uri, StringToJString('application/vnd.android.package-archive'));
    TAndroidHelper.Context.startActivity(intent);
    //Application.Terminate;
//  end;
end;

procedure TFormMain.btnPermissionClick(Sender: TObject);
begin
  //
  PermissionsService.RequestPermissions
    ([JStringToString(TJManifest_permission.JavaClass.READ_EXTERNAL_STORAGE),
    JStringToString(TJManifest_permission.JavaClass.REQUEST_INSTALL_PACKAGES),
    JStringToString(TJManifest_permission.JavaClass.WRITE_EXTERNAL_STORAGE)],
    procedure(const APermissions: TArray<string>;
      const AGrantResults: TArray<TPermissionStatus>)
    begin

    end);
end;

end.
